/*
Daytona Server API

Daytona Server API

API version: v0.0.0-dev
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package apiclient

import (
	"bytes"
	"encoding/json"
	"fmt"
)

// checks if the GitProvider type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &GitProvider{}

// GitProvider struct for GitProvider
type GitProvider struct {
	BaseApiUrl *string `json:"baseApiUrl,omitempty"`
	Id         string  `json:"id"`
	Token      string  `json:"token"`
	Username   string  `json:"username"`
}

type _GitProvider GitProvider

// NewGitProvider instantiates a new GitProvider object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewGitProvider(id string, token string, username string) *GitProvider {
	this := GitProvider{}
	this.Id = id
	this.Token = token
	this.Username = username
	return &this
}

// NewGitProviderWithDefaults instantiates a new GitProvider object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewGitProviderWithDefaults() *GitProvider {
	this := GitProvider{}
	return &this
}

// GetBaseApiUrl returns the BaseApiUrl field value if set, zero value otherwise.
func (o *GitProvider) GetBaseApiUrl() string {
	if o == nil || IsNil(o.BaseApiUrl) {
		var ret string
		return ret
	}
	return *o.BaseApiUrl
}

// GetBaseApiUrlOk returns a tuple with the BaseApiUrl field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GitProvider) GetBaseApiUrlOk() (*string, bool) {
	if o == nil || IsNil(o.BaseApiUrl) {
		return nil, false
	}
	return o.BaseApiUrl, true
}

// HasBaseApiUrl returns a boolean if a field has been set.
func (o *GitProvider) HasBaseApiUrl() bool {
	if o != nil && !IsNil(o.BaseApiUrl) {
		return true
	}

	return false
}

// SetBaseApiUrl gets a reference to the given string and assigns it to the BaseApiUrl field.
func (o *GitProvider) SetBaseApiUrl(v string) {
	o.BaseApiUrl = &v
}

// GetId returns the Id field value
func (o *GitProvider) GetId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Id
}

// GetIdOk returns a tuple with the Id field value
// and a boolean to check if the value has been set.
func (o *GitProvider) GetIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Id, true
}

// SetId sets field value
func (o *GitProvider) SetId(v string) {
	o.Id = v
}

// GetToken returns the Token field value
func (o *GitProvider) GetToken() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Token
}

// GetTokenOk returns a tuple with the Token field value
// and a boolean to check if the value has been set.
func (o *GitProvider) GetTokenOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Token, true
}

// SetToken sets field value
func (o *GitProvider) SetToken(v string) {
	o.Token = v
}

// GetUsername returns the Username field value
func (o *GitProvider) GetUsername() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Username
}

// GetUsernameOk returns a tuple with the Username field value
// and a boolean to check if the value has been set.
func (o *GitProvider) GetUsernameOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Username, true
}

// SetUsername sets field value
func (o *GitProvider) SetUsername(v string) {
	o.Username = v
}

func (o GitProvider) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o GitProvider) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.BaseApiUrl) {
		toSerialize["baseApiUrl"] = o.BaseApiUrl
	}
	toSerialize["id"] = o.Id
	toSerialize["token"] = o.Token
	toSerialize["username"] = o.Username
	return toSerialize, nil
}

func (o *GitProvider) UnmarshalJSON(data []byte) (err error) {
	// This validates that all required properties are included in the JSON object
	// by unmarshalling the object into a generic map with string keys and checking
	// that every required field exists as a key in the generic map.
	requiredProperties := []string{
		"id",
		"token",
		"username",
	}

	allProperties := make(map[string]interface{})

	err = json.Unmarshal(data, &allProperties)

	if err != nil {
		return err
	}

	for _, requiredProperty := range requiredProperties {
		if _, exists := allProperties[requiredProperty]; !exists {
			return fmt.Errorf("no value given for required property %v", requiredProperty)
		}
	}

	varGitProvider := _GitProvider{}

	decoder := json.NewDecoder(bytes.NewReader(data))
	decoder.DisallowUnknownFields()
	err = decoder.Decode(&varGitProvider)

	if err != nil {
		return err
	}

	*o = GitProvider(varGitProvider)

	return err
}

type NullableGitProvider struct {
	value *GitProvider
	isSet bool
}

func (v NullableGitProvider) Get() *GitProvider {
	return v.value
}

func (v *NullableGitProvider) Set(val *GitProvider) {
	v.value = val
	v.isSet = true
}

func (v NullableGitProvider) IsSet() bool {
	return v.isSet
}

func (v *NullableGitProvider) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableGitProvider(val *GitProvider) *NullableGitProvider {
	return &NullableGitProvider{value: val, isSet: true}
}

func (v NullableGitProvider) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableGitProvider) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
